import functools
import operator
from typing import (
    Union,
    Optional,
    Dict,
    Iterable,
    Any,
    Callable,
    List,
    Tuple,
)

import numpy as np
import torch

from .metric import Metric
import omlet.utils as U
import omegaconf
from omegaconf import OmegaConf
from omlet.distributed import global_master_only


class Session:
    def __init__(
            self,
            metrics: List[Union[Metric, str]],
            root_dir: str,
            backends,
            worker_ctx=None,
    ):
        self.metrics = {}
        for m in metrics:
            if isinstance(m, str):
                self.metrics[m] = Metric(name=m)
            elif isinstance(m, Metric):
                self.metrics[m.name] = m
            else:
                raise ValueError(f"Unsupported metric type {type(m)}")
        self.root_dir = U.f_expand(root_dir)
        self.worker_ctx = worker_ctx


